#include <SoftwareSerial.h> // Подключаем библиотеку для работы с Serial через дискретные порты
#include <iarduino_MultiServo.h>        //  Подключаем библиотеку iarduino_MultiServo
iarduino_MultiServo MSS;        
#define PIN_IN1 6 // Вывод управления направлением вращения мотора №1
#define PIN_IN2 7 // Вывод управления направлением вращения мотора №1
#define PIN_IN3 10 // Вывод управления направлением вращения мотора №2
#define PIN_IN4 11 // Вывод управления направлением вращения мотора №2
#define PIN_IN5 41 // Вывод управления направлением вращения мотора №3
#define PIN_IN6 43 // Вывод управления направлением вращения мотора №3
#define PIN_IN7 9 // Вывод управления направлением вращения мотора №4
#define PIN_IN8 8
#define PIN_IN9 4
#define PIN_IN10 5
int val=1;


// Пин для сервопривода

// Создаем объект

#include <SPI.h>                                          // Подключаем библиотеку  для работы с шиной SPI
#include <nRF24L01.h>                                     // Подключаем файл настроек из библиотеки RF24
#include <RF24.h>                                         // Подключаем библиотеку  для работы с nRF24L01+
int data[1];
RF24           radio(2, 3);                              // Создаём объект radio   для работы с библиотекой RF24, указывая номера выводов nRF24L01+ (CE, CSN)
                        
void setup(){
   MSS.servoSet(0, SERVO_SG90);         //  Сервопривод SG90 подключён к выводу № 0 MultiServoShield.
   MSS.servoSet(1, SERVO_SG90);    
// MSS.servoSet(SERVO_ALL, SERVO_SG90); //  На любом выводе используются только сервоприводы SG90
   MSS.begin();     
  Serial.begin(9600);
    
    radio.begin();                                        // Инициируем работу nRF24L01+
    radio.setChannel(20);                                  // Указываем канал приёма данных (от 0 до 127), 5 - значит приём данных осуществляется на частоте 2,405 ГГц (на одном канале может быть только 1 приёмник и до 6 передатчиков)
    radio.setDataRate     (RF24_250KBPS);                   // Указываем скорость передачи данных (RF24_250KBPS, RF24_1MBPS, RF24_2MBPS), RF24_1MBPS - 1Мбит/сек
    radio.setPALevel      (RF24_PA_MAX);                 // Указываем мощность передатчика (RF24_PA_MIN=-18dBm, RF24_PA_LOW=-12dBm, RF24_PA_HIGH=-6dBm, RF24_PA_MAX=0dBm)
    radio.openReadingPipe (1, 0x1234567890LL);            // Открываем 1 трубу с идентификатором 0x1234567890 для приема данных (на ожном канале может быть открыто до 6 разных труб, которые должны отличаться только последним байтом идентификатора)
    radio.startListening  ();                             // Включаем приемник, начинаем прослушивать открытую трубу
//  radio.stopListening   ();                             // Выключаем приёмник, если потребуется передать данные


}
void loop(){
    if(radio.available()){                                // Если в буфере имеются принятые данные
        radio.read(&data, sizeof(data));                  // Читаем данные в массив data и указываем сколько байт читать
        Serial.println(data[0]);
   MSS.servoWrite(1, 16*val);  
// Вперед
if (data[0] == 1) {
vforward();
}
// Назад
if (data[0] == 2)
{
vbackward();
}
// Влево
if (data[0] == 3)
{
vleft();
}
// Вправо
if (data[0] == 4)
{
vright();
}

// Стоп
if (data[0] == 0)
{
  digitalWrite(PIN_IN1, LOW);
  digitalWrite(PIN_IN2, LOW);
  digitalWrite(PIN_IN3, LOW);
  digitalWrite(PIN_IN4, LOW);
  digitalWrite(PIN_IN5, LOW);
  digitalWrite(PIN_IN6, LOW);
  digitalWrite(PIN_IN7, LOW);
  digitalWrite(PIN_IN8, LOW);
}
if (data[0] == 5)
{
vonbackconer();
}
if (data[0] == 6)
{
voffbackconer();
}
if (data[0] == 7)
{
 vonclaw(); 
}
if (data[0] == 8)
{
 voffclaw(); 
}
if (data[0] == 9)
{
 vonbackclaw(); 
}
if (data[0] == 10)
{
  voffbackclaw(); 
}
if (data[0] == 11)
{
 vonconer(); 
}
if (data[0] == 12)
{
  voffconer();
}
// Скорость 0%
if (data[0] == 13)
{
val=1;
}
// Скорость 10%
if (data[0] == 14)
{
val=2;
}
// Скорость 20%
if (data[0] == 15)
{
val=3;
}
// Скорость 30%
if (data[0] == 16)
{
  val=4;
}
// Скорость 40%
if (data[0] == 17)
{
val=5;
}
// Скорость 50%
if (data[0] == 18)
{
val=6;
}
// Скорость 60%
if (data[0] == 19)
{
val=7;
}
// Скорость 70%
if (data[0] == 20)
{
val=8;
}



// Скорость 80%
if (data[0] == 21)
{
val=9;
}
// Скорость 90%
if (data[0] == 22)
{
val=10;
}
// Скорость 100%
if (data[0] == 23)
{
val=11;
}
delay (10);
}

}



// Вперед
void vforward() {
// Задаём направление для 1-го мотора
    digitalWrite(PIN_IN2, LOW);
    digitalWrite(PIN_IN1, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN4, LOW);
    digitalWrite(PIN_IN3, HIGH);
    digitalWrite(PIN_IN6, LOW);
    digitalWrite(PIN_IN5, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN8, LOW);
    digitalWrite(PIN_IN7, HIGH);
}



// Назад
void vbackward() {
 digitalWrite(PIN_IN1, LOW);
    digitalWrite(PIN_IN2, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN3, LOW);
    digitalWrite(PIN_IN4, HIGH);
    digitalWrite(PIN_IN5, LOW);
    digitalWrite(PIN_IN6, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN7, LOW);
    digitalWrite(PIN_IN8, HIGH);

}



// Влево
void vleft() {
 digitalWrite(PIN_IN6, LOW);
    digitalWrite(PIN_IN5, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN8, LOW);
    digitalWrite(PIN_IN7, HIGH);
    digitalWrite(PIN_IN1, LOW);
    digitalWrite(PIN_IN2, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN3, LOW);
    digitalWrite(PIN_IN4, HIGH);
}

// Вправо
void vright() {
  digitalWrite(PIN_IN2, LOW);
    digitalWrite(PIN_IN1, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN4, LOW);
    digitalWrite(PIN_IN3, HIGH); 
    digitalWrite(PIN_IN5, LOW);
    digitalWrite(PIN_IN6, HIGH);
    // Задаём направление для 2-го мотора
    digitalWrite(PIN_IN7, LOW);
    digitalWrite(PIN_IN8, HIGH);
 
}
void vonclaw() {
  MSS.servoWrite(0, 10);  
    }
void voffclaw() {
  MSS.servoWrite(0, 180);  
}
void vonbackclaw() {
 
    }
void voffbackclaw() {
 
}
void vonconer() {
  digitalWrite(PIN_IN9, LOW);
    digitalWrite(PIN_IN10, HIGH);
    }
void voffconer() {
 digitalWrite(PIN_IN9, LOW);
    digitalWrite(PIN_IN10, LOW);
}
void vonbackconer() {
  digitalWrite(PIN_IN9, HIGH);
    digitalWrite(PIN_IN10, LOW);
    }
void voffbackconer() {
  digitalWrite(PIN_IN9, LOW);
    digitalWrite(PIN_IN10, LOW);
}



// Стоп
void vrelease(){
  digitalWrite(PIN_IN1, LOW);
  digitalWrite(PIN_IN2, LOW);
  digitalWrite(PIN_IN3, LOW);
  digitalWrite(PIN_IN4, LOW);
  digitalWrite(PIN_IN5, LOW);
  digitalWrite(PIN_IN6, LOW);
  digitalWrite(PIN_IN7, LOW);
  digitalWrite(PIN_IN8, LOW);
} 
   